<template>
  <footer
    class="ui-footer"
    :class="classList"
    ref="root"
  >
    <div class="wrapper">
      <div class="links-accordion" v-if="layoutRef === 'mobile'">
        <ui-accordion
          v-for="(linksGroup, index) in links"
          :title="linksGroup.label"
          :key="index"
        >
          <ul>
            <li
              v-for="(item, index) in linksGroup.items"
              :key="index"
            >
              <ui-link v-bind="item"/>
            </li>
          </ul>
        </ui-accordion>
      </div>
      <div 
        class="links"
        v-else
      >
        <ui-footer-links-group
          v-for="(linksGroup, index) in links"
          :key="index"
          :label="linksGroup.label"
          :items="linksGroup.items"
        />
      </div>
      <div
        class="widget"
        v-if="$slots.default"
      >
        <slot/>
      </div>
    </div>
  </footer>
</template>

<script lang="ts">
import type { UiLinkProps } from '../UiLink'
import { computed, defineComponent, PropType, ref } from 'vue'
import UiFooterLinksGroup from './UiFooterLinksGroup.vue'
import { UiLink } from '../UiLink'
import { UiAccordion } from '../UiAccordion'
import { UiFooterTokenWidget } from '../UiFooterTokenWidget'
import { templateRef, useResizeObserver } from '@vueuse/core'

type UiFooterLinksProp = {
  label: string,
  items: UiLinkProps[],
}[]

export default defineComponent({
  props: {
    links: {
      type: Array as PropType<UiFooterLinksProp>,
    },
  },
  setup() {
    const rootEl = templateRef<HTMLElement>('root')
    const layoutRef = ref<'desktop'|'tablet'|'mobile'>('desktop')
    const classList = computed(() => {
      const { value: layout } = layoutRef

      return `-${layout}`
    })

    useResizeObserver(rootEl, ([{ contentRect: { width } }]) => {
      layoutRef.value = 'desktop'

      if (width < 900) {
        layoutRef.value = 'tablet'
      }
      if (width < 600) {
        layoutRef.value = 'mobile'
      }
    })

    return {
      layoutRef,
      classList,
    }
  },
  components: {
    UiFooterLinksGroup,
    UiFooterTokenWidget,
    UiLink,
    UiAccordion,
  }
})
</script>

<style>
.ui-footer {
  @apply uikit-bg-black uikit-border-t uikit-border-gray-700;
  width: 100%;
}

.ui-footer > .wrapper {
  flex-direction: row;
  display: flex;
  width: 100%;
  margin-top: 32px;
}

.ui-footer.-mobile > .wrapper,
.ui-footer.-tablet > .wrapper {
  flex-direction: column-reverse;
}

.ui-footer > .wrapper > .links {
  display: flex;
  flex-grow: 1;
  margin-bottom: 32px;
}

.ui-footer > .wrapper > .links-accordion {
  margin-bottom: 32px;
}

.ui-footer > .wrapper > .widget {
  margin-bottom: 32px;
}
</style>